#!/usr/bin/python
# -*- coding: utf-8 -*-

from tkinter import *
from tkinter.messagebox import showinfo
from tkinter.simpledialog import askstring
from tkinter.filedialog import askopenfilename,asksaveasfilename
from os import getcwd,sep,mkdir,path


##############################
##                          ##
## Morpion solitaire v. 3.0 ##
##                          ##
##############################


sc,bn,flag,eff,nmf=0,0,0,0,""

def init_jeu(cas):
    global bn,sc,flag,xx,yy
    global Tem,curseur
    tracer.delete("all")    
    xx,yy,Tem=318,204,[]
    constructeur()
    curseur=tracer.create_polygon(xx-3,yy-3,xx+4,yy+4,xx+4,yy-3,xx-3,yy+4,xx-3,yy-3,fill="red")
    if cas==0:
        sc,bn,flag=0,0,0
    sco.set(str(sc).zfill(3))
    bns.set(str(bn).zfill(3))

def Sauver():
    global nmf,nomfich, bn,sc,flag,xx,yy
    global Tem,curseur,rep
    if nmf=="":
        SauverSous()
    else:
        lt,ld=len(nmf)-4,len(rep)+1
        nomfich=nmf[ld:lt]
        NomPartie(nomfich)     
        with open(nmf, 'w') as mrp:
            mrp.write(str(sc)+" "+str(bn)+" "+str(flag)+"\n")
            for li in range(34):
                for co in range(35):
                    a,b=Tem[li][co]
                    mrp.write(str(a)+" "+str(b)+"\n")
        mrp.close()

def SauverSous():
    global nmf,rep
    rep=getcwd()+sep+"Sauvegardes"
    nmf=asksaveasfilename(initialdir=rep,defaultextension='.mrs',).replace('/','\\')
    Sauver()


def charger():
    global sc,bn,flag,Tem,nomfich,nmf
    rep=getcwd()+sep+"Sauvegardes"
    if path.exists(rep):
        nmf=(askopenfilename(initialdir=rep)).replace('/','\\')
        with open(nmf,'r') as mrp:
            L=(mrp.readline().strip()).split()
            sc,bn,flag=int(L[0]),int(L[1]),int(L[2])
            init_jeu(1)
            sco.set(str(sc).zfill(3))
            bns.set(str(bn).zfill(3))
            for li in range(34):
                for co in range(35):
                    L=(mrp.readline().strip()).split()
                    Tem[li][co]=(int(L[0]),int(L[1]))
        mrp.close()
        lt,ld=len(nmf)-4,len(rep)+1
        nomfich=nmf[ld:lt]
        NomPartie(nomfich)
        traite_chrg()
    else:
        Msg(11,"_")

def traite_chrg():
    global bn,sc,flag,xx,yy
    global Tem,curseur,Croix
    decale=[(0,18),(18,0),(18,18),(-18,18)]
    for li in range(34):
        for co in range(35):
            a,b=Tem[li][co]
    for li in range(34):
        for co in range(35):
            a,b=Tem[li][co]
            xx,yy=48+co*18,60+li*18
            if a>=1:
                coul=["blue","black"][(li,co) in Croix]
                tracer.create_line(xx-4,yy,xx+5,yy,fill=coul,width=1)
                tracer.create_line(xx,yy-4,xx,yy+5,fill=coul,width=1)
                temoin=bin(b)[3:]
                for bt in range(0,8,2):
                    bit=temoin[bt]
                    if bit=="1":
                        dx,dy=decale[bt//2]
                        tracer.create_line(xx,yy,xx+dx,yy+dy,fill="blue",width=1)
    xx,yy=318,258
    tracer.coords(curseur,xx-3,yy-3,xx+4,yy+4,xx+4,yy-3,xx-3,yy+4,xx-3,yy-3)  

def NomPartie(nom):
    if tracer.find_withtag('titre'):
        tracer.delete('titre')
    tracer.create_text(10,5,text=nom,font=("Arial",10,"italic"),fill="blue",tag="titre",anchor="nw")

      
def place_croix():
    global xx,yy,flag,bn
    co,li=(xx-48)//18,(yy-60)//18
    a,b=Tem[li][co]
    if a>=1 :
        Msg(0,"_")
    else:
        flag+=1
        if flag>2:
            flag=1
            Msg(5,"_")
        else:
            if flag==2:
                if bn==0:
                    flag=1
                    Msg(6,"_")    
                else:
                    bn-=1
                    Tem[li][co]=(1,b)
                    tracer.create_line(xx-4,yy,xx+5,yy,fill='blue',width=1)
                    tracer.create_line(xx,yy-4,xx,yy+5,fill='blue',width=1)
                    bns.set(str(bn).zfill(3))
            elif flag==1:
                Tem[li][co]=(1,b)
                tracer.create_line(xx-4,yy,xx+5,yy,fill='blue',width=1)
                tracer.create_line(xx,yy-4,xx,yy+5,fill='blue',width=1)

def efface_croix():
    global flag,bn
    co, li=(xx-48)//18,(yy-60)//18
    a,p=Tem[li][co]
    if a==0:
        Msg(7,"_")
    elif a==2:
        Msg(9,"_")
    else:
        if p>256:
            Msg(8,"_")
        else:
            if flag!=0:
                flag-=1
                Tem[li][co]=(0,256)
                tracer.create_line(xx-4,yy,xx+5,yy,fill='white',width=1)
                tracer.create_line(xx,yy-4,xx,yy+5,fill='white',width=1)
                tracer.create_line(xx-1,yy,xx+2,yy,fill='blue',width=1)
                tracer.create_line(xx,yy-1,xx,yy+2,fill='blue',width=1)
                tracer.coords(curseur,xx-3,yy-3,xx+4,yy+4,xx+4,yy-3,xx-3,yy+4,xx-3,yy-3)
                if flag==1:
                    bn+=1
                    bns.set(str(bn).zfill(3))

def efface(trait):
    global Croix,Donnees_trace,Coords_trace,flag,xx,yy,eff,sc,bn
    if eff==0:
        Msg(10,"_")
        return
    T=Tem[:]
    sc,bn=Donnees_trace[0]
    flag,nul=Donnees_trace[1]
    sy,sx=Donnees_trace[2]
    for i in range(3,8):
        a,p=Donnees_trace[i]
        li,co=Coords_trace[i-3]
        Tem[li][co]=a,p
    tracer.delete(trait)
    eff=0
        
def trace_curseur(dx,dy):
    global xx,yy
    xx+=dx
    yy+=dy
    if xx==30:
        xx=660
    elif xx==678:
        xx=48
    if yy==42:
        yy=654
    elif yy==672:
        yy=60
    tracer.coords(curseur,xx-3,yy-3,xx+4,yy+4,xx+4,yy-3,xx-3,yy+4,xx-3,yy-3)
    
def nord():  
    trace_curseur(0,-18)

def nordw():  
    trace_curseur(-18,-18)
    
def norde():  
    trace_curseur(18,-18)

def est():  
    trace_curseur(18,0)

def sude():  
    trace_curseur(18,18)

def sud():  
    trace_curseur(0,18)

def sudw():  
    trace_curseur(-18,18)

def west():
    trace_curseur(-18,0)


def HB():
    global Donnees_trace,Coords_trace,eff,sc,trait
    co,li=(xx-48)//18,(yy-60)//18
    ok=1
    for j in range(5):
        a,p=Tem[li+j][co]
        if a==0:
            ok,no=0,["1ere","2e","3e","4e","5e"][j]
            Msg(1,no)
            break
        p_bin=bin(p)[3:5]
        rg8,rg7=p_bin[0:1],p_bin[1:2]
        if j==0:
            if rg8=="1":
                ok=0
                Msg(2,"_")
                break        
        elif j in [1,2,3]:
            if rg8=="1" or rg7=="1":
                ok=0
                no=["2e","3e","4e"][j-1]
                Msg(3,no)
                break 
        else:
           if rg7=="1":
               ok=0
               Msg(4,"_")
               break         
        if not ok:
            break
    if ok:
        Donnees_trace,Coords_trace,eff=[(sc,bn),(flag,0),(1,0)],[],1
        trait="Trait"+str(sc)
        tracer.create_line(xx,yy,xx,yy+72,fill='blue',width=1,tag=trait)
        score()
        for j in range(5):
            a,p=Tem[li+j][co]
            Donnees_trace.append((a,p))
            Coords_trace.append((li+j,co))
            if j==0:
                Tem[li+j][co]=(a,p+128)
            elif j in[1,2,3]:
                Tem[li+j][co]=(a,p+192)
            else:
                Tem[li+j][co]=(a,p+64)

def GD():
    global Donnees_trace,Coords_trace,eff,sc,trait
    co,li=(xx-48)//18,(yy-60)//18
    ok=1
    for j in range(5):
        a,p=Tem[li][co+j]
        if a==0:
            ok,no=0,["1ere","2e","3e","4e","5e"][j]
            Msg(1,no)
            break                                  
        p_bin=bin(p)[5:7]
        rg6,rg5=p_bin[0:1],p_bin[1:2]
        if j==0:
            if rg6=="1":
                ok=0
                Msg(2,"")
                break        
        elif j in [1,2,3]:
            if rg6=="1" or rg5=="1":
                ok,no=0,["2e","3e","4e"][j-1]
                Msg(3,no)
                break
        else:
           if rg5=="1":
               ok=0
               Msg(4,"")
               break         
        if not ok:
            break
    if ok:
        Donnees_trace,Coords_trace,eff=[(sc,bn),(flag,0),(0,1)],[],1
        trait="Trait"+str(sc)
        tracer.create_line(xx,yy,xx+72,yy,fill='blue',width=1,tag=trait)       
        score()
        for j in range(5):
            a,p=Tem[li][co+j]
            Donnees_trace.append((a,p))
            Coords_trace.append((li,co+j))
            if j ==0:
                Tem[li][co+j]=(a,p+32)
            elif j in[1,2,3]:
                Tem[li][co+j]=(a,p+48)
            else:
                Tem[li][co+j]=(a,p+16)
        
def HBE():
    global Donnees_trace,Coords_trace,eff,sc,trait
    co,li=(xx-48)//18,(yy-60)//18
    ok=1
    for j in range(5):
        a,p=Tem[li+j][co+j]
        if a==0:
            ok,no=0,["1ere","2e","3e","4e","5e"][j]
            Msg(1,no)
            break                                  
        p_bin=bin(p)[7:9]
        rg4,rg3=p_bin[0:1],p_bin[1:2]
        if j==0:
            if rg4=="1":
                Msg(2,"")
                ok=0
                break        
        elif j in [1,2,3]:
            if rg4=="1" or rg3=="1":
                ok,no=0,["2e","3e","4e"][j-1]
                Msg(3,no)
                break
        else:
           if rg3=="1":
               ok=0
               Msg(4,"")
               break         
        if not ok:
            break
    if ok:
        Donnees_trace,Coords_trace,eff=[(sc,bn),(flag,0),(1,1)],[],1
        trait="Trait"+str(sc)       
        tracer.create_line(xx,yy,xx+72,yy+72,fill='blue',width=1,tag=trait)
        score()
        for j in range(5):
            a,p=Tem[li+j][co+j]
            Donnees_trace.append((a,p))
            Coords_trace.append((li+j,co+j))
            if j==0:
                Tem[li+j][co+j]=(a,p+8)
            elif j in[1,2,3]:
                Tem[li+j][co+j]=(a,p+12)
            else:
                Tem[li+j][co+j]=(a,p+4)
                

def HBO():
    global Donnees_trace,Coords_trace,eff,sc,trait
    co,li=(xx-48)//18,(yy-60)//18
    ok=1
    for j in range(5):
        a,p=Tem[li+j][co-j]
        if a==0:
            ok,no=0,["1ere","2e","3e","4e","5e"][j]
            Msg(1,no)
            break                                  
        p_bin=bin(p)[9:11]
        rg2,rg1=p_bin[0:1],p_bin[1:2]
        if j==0:
            if rg2=="1":
                ok=0
                Msg(2,"_")
                break        
        elif j in [1,2,3]:
            if rg2=="1" or rg1=="1":
                ok,no=0,["2e","3e","4e"][j-1]
                Msg(3,no)
                break
        else:
           if rg1=="1":
               ok=0
               Msg(4,"")
               break         
        if not ok:
            break
    if ok:
        Donnees_trace,Coords_trace,eff=[(sc,bn),(flag,0),(1,-1)],[],1
        trait="Trait"+str(sc)
        tracer.create_line(xx,yy,xx-72,yy+72,fill='blue',width=1,tag=trait)
        score()
        for j in range(5):
            a,p=Tem[li+j][co-j]
            Donnees_trace.append((a,p))
            Coords_trace.append((li+j,co-j))
            if j==0:
                Tem[li+j][co-j]=(a,p+2)
            elif j in[1,2,3]:
                Tem[li+j][co-j]=(a,p+3)
            else:
                Tem[li+j][co-j]=(a,p+1)

def Msg(m,no):
    Fenetre.bell()
    if m==0:
        showinfo('Erreur', "Cette croix existe déjà")
    elif m==1:
        showinfo('Erreur', "Il manque la "+no+" croix dans la direction choisie")       
    elif m==2:
        showinfo('Erreur', "Un trait part déjà de la 1ere croix dans cette direction")
    elif m==3:
        showinfo('Erreur', "Un trait passe déjà par la "+no+" dans cette direction")
    elif m==4:
        showinfo('Erreur', "Un trait arrive déjà sur la 5e croix dans cette direction")
    elif m==5:
        showinfo('Erreur', "Il est interdit de poser plus de 2 croix consécutives")
    elif m==6:
        showinfo('Erreur', "Bonus nul. Vous ne pouvez poser une 2e croix consécutive")
    elif m==7:
        showinfo('Erreur', "Il n'y a pas de croix à cet emplacement")
    elif m==8:
        showinfo('Erreur', "Suppression impossible : cette croix est déjà utilisée")
    elif m==9:
        showinfo('Erreur', "Suppression impossible : cette croix est d'origine")
    elif m==10:
        showinfo('Erreur', "Suppression non autorisée !")
    else:
        showinfo('Erreur', "Le dossier Sauvegardes n'existe pas !")


def score():
    global sc,bn,flag
    sc+=1
    sco.set(str(sc).zfill(3))
    if flag==0:
        bn+=1
        bns.set(str(bn).zfill(3))
    flag=0

    
def constructeur():
    global Tem,Croix,eff
    Tem,B,eff=[],[],0
    Croix=[(9,15),(9,16),(9,17),(9,18),(10,15),(10,18),(11,15),(11,18),(12,12),\
           (12,13),(12,14),(12,15),(12,18),(12,19),(12,20),(12,21),(13,12),(13,21),\
           (14,12),(14,21),(15,12),(15,13),(15,14),(15,15),(15,18),(15,19),(15,20),\
           (15,21),(16,15),(16,18),(17,15),(17,18),(18,15),(18,16),(18,17),(18,18)]

    for y in range(60,667,18):      #placement des repères
        for x in range(48,661,18):
            tracer.create_line(x-1,y,x+2,y,fill='blue',width=1) 
            tracer.create_line(x,y-1,x,y+2,fill='blue',width=1)
            B.append((0,256))
        Tem.append(B)
        B=[]

    for li,co in Croix:             #placement des croix initiales et initialisation
        Tem[li][co]=(2,256)
        y,x=li*18+60,co*18+48 
        tracer.create_line(x-4,y,x+5,y,fill='black',width=1) 
        tracer.create_line(x,y-4,x,y+5,fill='black',width=1)


try:
    mkdir(getcwd()+sep+"Sauvegardes")
except OSError:
    pass
Fenetre=Tk()
Fenetre.title("Morpion solitaire")
Fenetre.geometry("1000x740")
Fenetre.resizable(height=False, width=False)
V=PhotoImage(file='Vert.gif')
H=PhotoImage(file='GD.gif')
G=PhotoImage(file='HBE.gif')
D=PhotoImage(file='HBO.gif')
menubar = Menu(Fenetre)
filemenu = Menu(menubar, tearoff=0)
menubar.add_cascade(label="Fichier", menu=filemenu)
filemenu.add_command(label="Nouvelle partie",command=lambda: init_jeu(0))
filemenu.add_command(label="Charger fichier",command=charger)
filemenu.add_command(label="Enregistrer",command=Sauver)
filemenu.add_command(label="Enregistrer sous",command=SauverSous)
filemenu.add_separator()
filemenu.add_command(label="Quitter",command=Fenetre.destroy)

editmenu = Menu(menubar, tearoff=0)
menubar.add_cascade(label="Edition", menu=editmenu)
editmenu.add_command(label='Effacer croix',command=efface_croix)
editmenu.add_command(label="Effacer dernier trait",command=lambda: efface(trait))
Fenetre.config(menu=menubar)


tracer = Canvas(Fenetre,width=800,height=700,bg='white',bd=1,relief="groove")
tracer.grid(column=0,row=2, rowspan=100)
label = Label(Fenetre, text="Déplacements",font=("Arial",14,"bold"))
label.grid(column=2,columnspan=3, row=0)
label1 = Label(Fenetre, text="Tracés des traits",font=("Arial",14,"bold"))
label1.grid(column=2,columnspan=3, row=20)
label2 = Label(Fenetre, text = "Score", font=("Arial",10,"bold"),fg="blue")
label2.grid(column=2, row=40)
label3 = Label(Fenetre, text = "Bonus", font=("Arial",10,"bold"),fg="#02CC1C")
label3.grid(column=2, row=41)
sco=StringVar()
sco.set(str(sc).zfill(3))
labelscore = Label(Fenetre, textvariable=sco)
labelscore.config(bg="white",fg='blue')
labelscore.grid(column=3,row=40)
bns=StringVar()
bns.set(str(bn).zfill(3))
labelbonus = Label(Fenetre, textvariable=bns)
labelbonus.config(bg="white",fg='#02CC1C')
labelbonus.grid(column=3,row=41)      

Button(Fenetre,text='Nord-Ouest',command=nordw,fg="red").grid(column=2, row=7)
Button(Fenetre,text='Nord',command=nord,fg="red").grid(column=3, row=7)
Button(Fenetre,text='Nord-Est',command=norde,fg="red").grid(column=4, row=7)

Button(Fenetre,text='Ouest',command=west,fg="red").grid(column=2, row=8)
Button(Fenetre,text='+',font=("Arial",14,"bold"),fg='blue',command=place_croix).grid(column=3, row=8)

Button(Fenetre,text='Est',command=est,fg="red").grid(column=4, row=8)
Button(Fenetre,text='Sud-Ouest',command=sudw,fg="red").grid(column=2, row=9)
Button(Fenetre,text='Sud-Est',command=sude,fg="red").grid(column=4, row=9)
Button(Fenetre,text='Sud',command=sud,fg="red").grid(column=3, row=9)

Button(Fenetre,image=H,command=GD).grid(column=2, row=24,sticky="E")
Button(Fenetre,image=V,command=HB).grid(column=4, row=24,sticky="W")
Button(Fenetre,image=G,command=HBE).grid(column=2, row=26,sticky="E")
Button(Fenetre,image=D,command=HBO).grid(column=4, row=26,sticky="W")

init_jeu(0)
NomPartie("NouvellePartie")
Fenetre.mainloop()

